<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Variant Calling Pipeline: Variant Calling Pipeline</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Variant Calling Pipeline
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Variant Calling Pipeline </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>Version: 3.2.0 <br />
 Contact: <a href="#" onclick="location.href='mai'+'lto:'+'BI-'+'Su'+'ppo'+'rt'+'@rk'+'i.'+'de'; return false;">BI-Su<span style="display: none;">.nosp@m.</span>ppor<span style="display: none;">.nosp@m.</span>t@rki<span style="display: none;">.nosp@m.</span>.de</a> <br />
 25.07.2017</p>
<h2>Editing this page</h2>
<p>This is a copy of the <code>README.md</code> of the main directory.</p>
<p>The includes of <code>VC_flowchart.png</code> needs to be changed from <code>./*.png</code> to <code>../../*.png</code>.</p>
<h2>Introduction</h2>
<p>This is a pipeline for the identification and annotation of genetic variants using Next Generation Sequencing (NGS) data. It is able to call SNPs and short InDels according to a given reference sequence. The BAM files of the Mapping pipeline output can be used as input for the batch processing mode, together with the reference sequence (genbank file) that has been used by the Mapping pipeline for the same dataset.</p>
<p>This tool was implemented in Python and needs Python 3.4 or higher. The pipeline uses the following tools:</p>
<table class="doxtable">
<tr>
<th>Tool name </th><th>Version </th><th>Pubmed ID  </th></tr>
<tr>
<td><a href="https://bitbucket.org/snakemake/snakemake/wiki/Home">Snakemake</a> </td><td>3.11.2 </td><td><a href="https://www.ncbi.nlm.nih.gov/pubmed/22908215">22908215</a> </td></tr>
<tr>
<td><a href="http://www.htslib.org/">Samtools</a></td><td>1.3.1 </td><td><a href="https://www.ncbi.nlm.nih.gov/pubmed/19505943">19505943</a> </td></tr>
<tr>
<td><a href="https://broadinstitute.github.io/picard/">Picard</a> </td><td>2.7.1 </td><td></td></tr>
<tr>
<td><a href="https://www.broadinstitute.org/gatk/download/">GATK</a></td><td>3.7 </td><td><a href="https://www.ncbi.nlm.nih.gov/pubmed/20644199">20644199</a> </td></tr>
<tr>
<td><a href="http://snpeff.sourceforge.net/">snpEff</a> </td><td>4.2 </td><td><a href="https://www.ncbi.nlm.nih.gov/pubmed/22728672">22728672</a> </td></tr>
</table>
<p>The workflow used in the pipeline is visualized in the following chart:</p>
<div class="image">
<img src="../../VC_flowchart.png" alt="Workflow of the variant calling pipeline:" title="Workflow image"/>
</div>
 <hr/>
 <h2>Tutorial</h2>
<p>The general call of the pipeline is shown below: </p><div class="fragment"><div class="line">variant_calling-3 --reference &lt;genbank&gt; --input &lt;mapping&gt; --picard &lt;picard&gt; --snpeff &lt;snpeff&gt; --gatk &lt;gatk&gt; &lt;option(s)&gt;</div></div><!-- fragment --><p> Calling the pipeline with the option <code>-h</code> provides a help message listing all options: <code>variant_calling-3 -h</code>.</p>
<p>A toy dataset is provided in the data-folder <code>/pipelines/datasets/mapping_outcome</code>, which is the outcome of the mapping pipeline using the toy dataset. The following example uses this dataset to demonstrate a basic run of the pipeline:</p>
<div class="fragment"><div class="line">variant_calling-3 --reference /pipelines/datasets/references/toy_reference.gb --input /pipelines/datasets/mapping_outcome/joined.bam --output ./varcall --threads 48 --msa --majority </div></div><!-- fragment --><p> Please note that the reference sequence should be the same as that has been used in the mapping procedure. </p><hr/>
 <h2>Options</h2>
<p>The following paragraphs describe the options of the pipeline in detail. Notice that any additional arguments that are not recognized by <code>variant_calling-3</code> are passed to Snakemake (i.e. the pipeline can be run with any additional parameter that can be parsed by Snakemake). As an example, the command <code>variant_calling-3 --config example.json --nt</code> will pass <code>--nt</code> to Snakemake, causing Snakemake to retain temporary files.</p>
<h4>Help</h4>
<blockquote class="doxtable">
<p>Long option: <code>--help</code> <br />
 Short option: <code>-h</code> </p>
</blockquote>
<p>Show the help messages and exit</p>
<h4>Version</h4>
<blockquote class="doxtable">
<p>Long option: <code>--version</code> <br />
 Short option: <code>-v</code> </p>
</blockquote>
<p>Show the pipeline's version number and exit</p>
<h4>Reference</h4>
<blockquote class="doxtable">
<p>Long option: <code>--reference &lt;REFERENCE&gt;</code> <br />
 Short option: <code>-r &lt;REFERENCE&gt;</code> </p>
</blockquote>
<p>Path to GenBank file that is used as reference sequence. This is a required parameter. GenBank files may be acquired from <a href="http://www.ncbi.nlm.nih.gov/genbank/">NCBI</a>. When downloading GenBank files from NCBI, make sure to include the sequence (<em>Customize view</em> -&gt; <em>Display options</em> -&gt; <em>Show sequence</em>) before downloading the file (<em>Send</em> -&gt; <em>Complete record</em> -&gt; <em>File</em> -&gt; <em>GenBank (full)</em>). Alternatively, the reference sequence can be saved as GenBank file from <b>Geneious</b>.</p>
<h4>Input</h4>
<blockquote class="doxtable">
<p>Long option: <code>--input &lt;INPUT&gt;</code> <br />
 Short option: <code>-i &lt;INPUT&gt;</code> </p>
</blockquote>
<p>Path to the mapping file in either SAM or BAM format. When the Mapping pipeline has been employed for the mapping procedure in the first place, the input is the BAM output of the Mapping pipeline, together with the reference sequence (genbank file) that has been used in the Mapping pipeline. I this case, all alignments should be reported in the input alignment file, including secondary alignments. Per default, alignment files generated by <a href="https://gitlab.com/RKIBioinformaticsPipelines/Mapping">Mapping pipeline</a> fulfill this requirement. Otherwise, use the option <code>-M</code> for bwa-mem or <code>-a</code> for Bowtie2. If readgroups have been set, the alignment file may contain multiple samples and the naming scheme is arbitrary. <b>If readgroups are not set</b>, separate alignment files for each sample are required. In this case, the alignment files need to conform to the following naming scheme:</p><ul>
<li>Scheme: <code>SAMPLENAME_LANE_READ_NUMBER.&lt;sam/bam&gt;</code></li>
<li>Regular expression: <code>(.*)_L[\d]+_R[\d]+_[\d]+.(sam|bam)</code></li>
<li>Example: <code>15_146_M_abscessus_10265_12_TAAGGCGA-CTCTCTAT_L001_R1_001.sam</code></li>
</ul>
<h4>Picard</h4>
<blockquote class="doxtable">
<p>Long option: <code>--picard &lt;PICARD</code> </p>
</blockquote>
<p>Path to picard directory</p>
<h4>Snpeff</h4>
<blockquote class="doxtable">
<p>Long option: <code>--snpeff &lt;SNPEFF&gt;</code> </p>
</blockquote>
<p>Path to snpEff directory</p>
<h4>Gatk</h4>
<blockquote class="doxtable">
<p>Long option: <code>--gatk &lt;GATK&gt;</code> </p>
</blockquote>
<p>Path to GATK directory containing GenomeAnalysisTK.jar</p>
<h4>Samtools</h4>
<blockquote class="doxtable">
<p>Long option: <code>--samtools &lt;SAMTOOLS&gt;</code> </p>
</blockquote>
<p>Path to samtools directory. Default: <code>/usr/bin/</code>.</p>
<h4>Elprep</h4>
<blockquote class="doxtable">
<p>Long option: <code>--elprep &lt;ELPREP&gt;</code> </p>
</blockquote>
<p>Path to elPrep directory</p>
<h4>Output</h4>
<blockquote class="doxtable">
<p>Long option: <code>--output &lt;OUTPUT&gt;</code> <br />
 Short option: <code>-o &lt;OUTPUT&gt;</code> </p>
</blockquote>
<p>Output directory</p>
<h4>Log</h4>
<blockquote class="doxtable">
<p>Long option: <code>--log &lt;LOG&gt;</code> <br />
 Short option: <code>-l &lt;LOG&gt;</code> </p>
</blockquote>
<p>Locate where the log file shall be saved</p>
<h4>Annotate all</h4>
<blockquote class="doxtable">
<p>Long option: <code>--annotate_all</code> </p>
</blockquote>
<p>Report also variants in non-coding regions. Default: only variants in the coding regions will be reported.</p>
<h4>Decimal sep</h4>
<blockquote class="doxtable">
<p>Long option: <code>--decimal_sep &lt;DECIMAL_SEP&gt;</code> </p>
</blockquote>
<p>Set the default decimal separator, e.g. 10.323 or 10,323. (Default: ,)</p>
<h4>Threads</h4>
<blockquote class="doxtable">
<p>Long option: <code>--threads &lt;THREADS&gt;</code> <br />
 Short option: <code>-t &lt;THREADS&gt;</code> </p>
</blockquote>
<p>Set maximal number of threads. Default: 1.</p>
<h4>Ploidy</h4>
<blockquote class="doxtable">
<p>Long option: <code>--ploidy &lt;PLOIDY&gt;</code> </p>
</blockquote>
<p>Sample ploidy for GATK. Default: 1</p>
<h4>Msa</h4>
<blockquote class="doxtable">
<p>Long option: <code>--msa</code> </p>
</blockquote>
<p>Generate a multiple sequence alignment (FASTA-format) out of the consensus sequences of each sample. In case of single sample, the consensus sequence of this sample is written to file.</p>
<h4>Ambiguity cutoff</h4>
<blockquote class="doxtable">
<p>Long option: <code>--ambiguity_cutoff &lt;AMBIGUITY_CUTOFF&gt;</code> </p>
</blockquote>
<p>This option is used to define the minimum percent of coverage difference of a variant position that is to be treated as ambiguous in the consensus sequence. Default: 5%. For example, <code>--ambiguity_cutoff 5</code> will encode the genotype A/T as W if the lower coverage of the reference allele A and the alternative allele T represents at least 5 % of the total coverage.</p>
<h4>Majority</h4>
<blockquote class="doxtable">
<p>Long option: <code>--majority</code> </p>
</blockquote>
<p>Use majority vote for called alleles in the consensus sequence generation. For example, if the called genotype is A/T and the reference allele A has a higher coverage than the alternative allele T, then A is used for the consensus sequence. If both alleles have the same coverage, ambiguous encoding is used.</p>
<h4>Java</h4>
<blockquote class="doxtable">
<p>Long option: <code>--java &lt;JAVA&gt;</code> </p>
</blockquote>
<p>Give the path to Java version 1.8+ executable.</p>
<h4>Config</h4>
<blockquote class="doxtable">
<p>Long option: <code>--config &lt;CONFIG&gt;</code> <br />
 Short option: <code>-c &lt;CONFIG&gt;</code> </p>
</blockquote>
<p>Define a config file in yaml format with preset parameters. If both config file and command parameters are given, the parameters given on the commandline supersede the parameters given in the config file. Thus, a config file can be used to personalize default parameters, and deviations from these personal defaults can be given via the command-line.</p>
<p>For instance, in order to run the pipeline with 24 threads using <code>"~/SCRATCH_NOBAK/runs/newest_run"</code> as input, <code>"~/SCRATCH_NOBAK/runs/newest_vcres"</code> as output and <code>"~/references/myreference.gb"</code> as reference, the following config file could be used (<code>"~/example.yaml"</code>):</p>
<div class="fragment"><div class="line">threads: 24</div><div class="line">input: &quot;~/SCRATCH_NOBAK/runs/newest_run&quot;</div><div class="line">output: &quot;~/SCRATCH_NOBAK/runs/newest_vcres&quot;</div><div class="line">reference: &quot;~/references/myreference.gb&quot;</div></div><!-- fragment --><p>The pipeline could then be started using the following command:</p>
<div class="fragment"><div class="line">variant_calling-3 --config ~/example.yaml</div></div><!-- fragment --><p>If then a a run of the pipeline is to be started with the same parameters but with 12 threads, this can be achieved with the following command (re-using the config file and overriding the threads option instead of giving all paramenters on the commandline manually):</p>
<div class="fragment"><div class="line">variant_calling-3 --config ~/example.yaml --threads 12</div></div><!-- fragment --> <hr/>
 <h2>Output description</h2>
<p>By default, the pipeline generates the following files in the output folder (default folder: the same folder as that of the SAM/BAM file).</p>
<ul>
<li>Annotated VCF: VCF file with annotation</li>
<li>PDF report file and its tex auxiliary files</li>
<li>Cleaned bam alignment file with Readgroup information: this is the processed BAM file output from GATK.</li>
<li>Consensus sequences of all samples as alignment</li>
<li>Variant summary output of snpEff</li>
<li>Complete table: summary of variant calling results over all samples</li>
<li>Log files</li>
</ul>
<hr/>
 <h2>Benchmarking</h2>
<p>The variant calling pipeline's ability to recover known variants was tested using results of bowtie2-mapping (using the mapping pipeline) of a real and an artificial dataset.</p>
<p>The real dataset is an unpublished paired end 300+300bp MiSeq re-sequencing of an Enterovirus with 10 known, Sanger-verified SNPs towards the reference sequence. Using the mapping (&ndash;mapper bowtie2, default parameters otherwise) and variant calling pipelines (&ndash;annotate_all, default parameters otherwise), all 10 SNPs could be recovered without any false positives being called.</p>
<p>The artificial dataset consists of 8 datasets simulated using QuReSim from a Klebsiella pneumoniae reference (NC_016845.1) that was randomly modified at 44410 positions prior to read simulation. 200+200bp and 300+300bp paired-end illumina reads were simulated at 20-, 50-, 100- and 200-fold coverage, yielding 8 datasets. All datasets were mapped in batch mode using the mapping pipeline (&ndash;mapper bowtie2, default parameters otherwise) and variant calling (&ndash;annotate_all, default parameters otherwise) was performed using the variant calling pipeline. The resulting vcf files were compared to the previously introduced modifications using vcftools. The resulting numbers of true and false positives and the resulting recall are recorded in the tables below:</p>
<table class="doxtable">
<tr>
<th>True Positives [#] </th><th>20x </th><th>50x </th><th>100x </th><th>200x  </th></tr>
<tr>
<td>200+200bp </td><td>43821 </td><td>43879 </td><td>43890 </td><td>43901 </td></tr>
<tr>
<td>300+300bp </td><td>43772 </td><td>43851 </td><td>43860 </td><td>43878 </td></tr>
</table>
<table class="doxtable">
<tr>
<th>Recall </th><th>20x </th><th>50x </th><th>100x </th><th>200x  </th></tr>
<tr>
<td>200+200bp </td><td>98.67 </td><td>98.80 </td><td>98.82 </td><td>98.85 </td></tr>
<tr>
<td>300+300bp </td><td>98.56 </td><td>98.74 </td><td>98.76 </td><td>98.80 </td></tr>
</table>
<table class="doxtable">
<tr>
<th>False Positives [#] </th><th>20x </th><th>50x </th><th>100x </th><th>200x  </th></tr>
<tr>
<td>200+200bp </td><td>56 </td><td>36 </td><td>24 </td><td>32 </td></tr>
<tr>
<td>300+300bp </td><td>68 </td><td>44 </td><td>56 </td><td>52 </td></tr>
</table>
<hr/>
<h2>Changelog</h2>
<ul>
<li>3.2.0: Reworked readgroup assignment</li>
<li>3.1.0: Added snpfilter</li>
<li>3.0.0: Adaptions for the wrapper-pipeline</li>
<li>2.0.5: Fix SnpEff missing annotations</li>
<li>2.0.4: Added report</li>
<li>2.0.3: Parameter names are now unified across all RKI Bioinformatics Service Pipelines</li>
<li>2.0.2: Executable name now contains major version</li>
<li>2.0.1: Increased Java heap size for GATK</li>
<li>2.0: Initial release of the stable version</li>
<li>1.0: Initial version for internal testing <hr/>
 <h2>License</h2>
</li>
</ul>
<p>This program is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License, version 3 as published by the Free Software Foundation.</p>
<p>This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</p>
<p>You should have received a copy of the GNU Lesser General Public License along with this program. If not, see <a href="http://www.gnu.org/licenses/">http://www.gnu.org/licenses/</a>. </p>
</div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
